SystemOrganization addCategory: #'NautilusExtraPlugin-JannikAlgo'!

Trait named: #MalTGraphBuilder
	uses: {}
	category: 'NautilusExtraPlugin-JannikAlgo'!

!MalTGraphBuilder methodsFor: 'private' stamp: 'simon.denier 9/27/2010 17:37'!
addEdge: eModel from: source to: target 

	| edge sourceNode targetNode unknownNode |
	unknownNode := false.
	sourceNode := self 	findNode: (source value: eModel)
							ifAbsent: [ unknownNode := true ].
	targetNode := self 	findNode: (target value: eModel)
							ifAbsent: [ unknownNode := true ].

	unknownNode ifFalse: [
		self edgeClass ifNil: [
			sourceNode to: targetNode.
			targetNode from: sourceNode.
			^ nil
		] ifNotNil: [
			edge := self edgeClass with: eModel.
			sourceNode to: targetNode edge: edge.
			targetNode from: sourceNode edge: edge.
			edge from: sourceNode.
			edge to: targetNode.
			self edges add: edge.	
			^ edge
		]		
	].
	^ nil! !

!MalTGraphBuilder methodsFor: 'configuration' stamp: 'simon.denier 9/27/2010 17:33'!
edgeClass

	^ nil! !

!MalTGraphBuilder methodsFor: 'accessing' stamp: 'simon.denier 9/27/2010 17:34'!
edges
	
	self explicitRequirement! !

!MalTGraphBuilder methodsFor: 'configuration' stamp: 'simon.denier 9/27/2010 17:37'!
edges: aCollection from: source to: target

	aCollection do: [ :eModel |
		self addEdge: eModel from: source to: target
	]! !

!MalTGraphBuilder methodsFor: 'configuration' stamp: 'simon.denier 9/27/2010 17:34'!
edges: aCollection from: source to: target weight: weightFunction

	| edge |
	aCollection do: [ :eModel |
		edge := self addEdge: eModel from: source to: target.
		edge ifNotNil: [edge weight: (weightFunction value: eModel)].
	]! !

!MalTGraphBuilder methodsFor: 'configuration' stamp: 'simon.denier 9/27/2010 17:37'!
edges: aCollection from: source toAll: targets

	aCollection do: [ :eModel |
		(targets value: eModel) do: [:target| 
			self addEdge: {source value: eModel. target} from: #first to: #second
		]
	]! !

!MalTGraphBuilder methodsFor: 'accessing' stamp: 'simon.denier 9/27/2010 17:34'!
findEdge: aModel

	^ self edges detect: [:edge | edge model = aModel]! !

!MalTGraphBuilder methodsFor: 'accessing' stamp: 'simon.denier 9/27/2010 17:34'!
findNode: aModel

	^ self nodes detect: [:aNode | aNode model = aModel ]! !

!MalTGraphBuilder methodsFor: 'accessing' stamp: 'simon.denier 9/27/2010 17:35'!
findNode: aModel ifAbsent: aBlock

	^ self nodes detect: [:node | node model = aModel] ifNone: aBlock! !

!MalTGraphBuilder methodsFor: 'accessing' stamp: 'simon.denier 9/27/2010 17:35'!
graph

	^ {self nodes. self edges}! !

!MalTGraphBuilder methodsFor: 'configuration' stamp: 'simon.denier 9/30/2010 14:46'!
nodeClass

	^ MalGraphNode! !

!MalTGraphBuilder methodsFor: 'accessing' stamp: 'simon.denier 9/27/2010 17:35'!
nodes
	
	self explicitRequirement! !

!MalTGraphBuilder methodsFor: 'configuration' stamp: 'simon.denier 9/27/2010 17:35'!
nodes: aCollection

	aCollection do: [ :model |
		self nodes add: (self nodeClass with: model)
	]
! !

Trait named: #MalTNodeNode
	uses: {}
	category: 'NautilusExtraPlugin-JannikAlgo'!

!MalTNodeNode methodsFor: 'accessing' stamp: 'simondenier 2/8/2010 22:14'!
from: sourceNode

	self previousNodes add: sourceNode ! !

!MalTNodeNode methodsFor: 'accessing' stamp: 'simondenier 2/8/2010 22:15'!
nextNodes

	self explicitRequirement! !

!MalTNodeNode methodsFor: 'accessing' stamp: 'simondenier 2/8/2010 22:14'!
previousNodes

	self explicitRequirement! !

!MalTNodeNode methodsFor: 'accessing' stamp: 'simondenier 2/8/2010 22:14'!
to: targetNode

	self nextNodes add: targetNode ! !

Trait named: #MalTNormalize
	uses: {}
	category: 'NautilusExtraPlugin-JannikAlgo'!

!MalTNormalize methodsFor: 'running' stamp: 'simondenier 3/17/2010 22:26'!
normalize: aCollectionOfNodes

	| firstNode perm |
	firstNode := aCollectionOfNodes detectMin: [:n| n printString ].
	perm := aCollectionOfNodes copy.
	[ firstNode = perm first ] whileFalse: [
		perm addLast: perm removeFirst ].
	^ perm! !

Object subclass: #MalGraphAlgorithm
	uses: MalTGraphBuilder
	instanceVariableNames: 'nodes edges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusExtraPlugin-JannikAlgo'!

MalGraphAlgorithm class
	uses: MalTGraphBuilder classTrait
	instanceVariableNames: ''!

!MalGraphAlgorithm methodsFor: 'accessing' stamp: 'simon.denier 9/27/2010 17:36'!
edges

	^ edges! !

!MalGraphAlgorithm methodsFor: 'accessing' stamp: 'jannik.laval 12/10/2010 23:17'!
findNode: aModel

	^ self nodes detect: [:aNode | aNode model = aModel ]! !

!MalGraphAlgorithm methodsFor: 'initialize-release' stamp: 'simon.denier 7/24/2009 11:35'!
initialize

	nodes := OrderedCollection new.
	edges := OrderedCollection new.! !

!MalGraphAlgorithm methodsFor: 'configuration' stamp: 'simon.denier 9/28/2010 13:18'!
nodeClass

	^ MalGraphNode! !

!MalGraphAlgorithm methodsFor: 'accessing' stamp: 'simon.denier 7/6/2009 16:58'!
nodes

	^ nodes! !

!MalGraphAlgorithm methodsFor: 'private' stamp: 'simondenier 2/8/2010 22:40'!
privateEdges: aCollection

	edges := aCollection ! !

!MalGraphAlgorithm methodsFor: 'private' stamp: 'simondenier 2/8/2010 22:39'!
privateNodes: aCollection

	nodes := aCollection ! !

!MalGraphAlgorithm methodsFor: 'running' stamp: 'simon.denier 7/10/2009 18:19'!
run

	self subclassResponsibility ! !

MalGraphAlgorithm subclass: #MalSccExtractor
	instanceVariableNames: 'circuits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusExtraPlugin-JannikAlgo'!

!MalSccExtractor methodsFor: 'accessing' stamp: 'simon.denier 3/19/2010 23:53'!
addCircuit: aCollectionOfNodes
	
	circuits add: aCollectionOfNodes! !

!MalSccExtractor methodsFor: 'accessing' stamp: 'simon.denier 3/19/2010 23:53'!
circuits
	^ circuits! !

!MalSccExtractor methodsFor: 'accessing' stamp: 'simon.denier 3/19/2010 23:56'!
initialize 

	super initialize.
	circuits := Set new.
! !

!MalSccExtractor methodsFor: 'running' stamp: 'simon.denier 3/19/2010 23:54'!
run

	self subclassResponsibility! !

MalSccExtractor subclass: #MalSccNodeDecomposition
	uses: MalTNormalize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusExtraPlugin-JannikAlgo'!

MalSccNodeDecomposition class
	uses: MalTNormalize classTrait
	instanceVariableNames: ''!

!MalSccNodeDecomposition methodsFor: 'running' stamp: 'simon.denier 9/28/2010 13:18'!
nodeClass

	^ MalSndNode! !

!MalSccNodeDecomposition methodsFor: 'running' stamp: 'simon.denier 3/20/2010 19:09'!
retrieveCircuit: aNode

	|c n i|
	c := OrderedCollection new.
	i := aNode.
	[ i notNil ] whileTrue: [
		c addFirst: i model.
		i := i bfsAncestor.
	].
	^ c! !

!MalSccNodeDecomposition methodsFor: 'running' stamp: 'simon.denier 3/20/2010 18:09'!
run

	self nodes do: [:n|
		self run: n
	]! !

!MalSccNodeDecomposition methodsFor: 'running' stamp: 'simon.denier 3/20/2010 19:07'!
run: aNode

	| fifo visited ancestors |
	visited := Set new.
	ancestors := aNode previousNodes.
	aNode bfsAncestor: nil.
	fifo := OrderedCollection with: aNode.
	[ancestors isEmpty] whileFalse: [ |p|
		p := fifo removeFirst.
		p nextNodes do: [:next|
			((visited includes: next) or: [fifo includes: next])
				ifFalse: [
					next bfsAncestor: p.
					fifo addLast: next ].
			(ancestors includes: next)
				ifTrue: [ |c|
					c := self retrieveCircuit: next.
					self addCircuit: (self normalize: c).
					ancestors remove: next ]
		].
		visited add: p ]! !

MalGraphAlgorithm subclass: #MalTarjan
	instanceVariableNames: 'stack runningIndex sccs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusExtraPlugin-JannikAlgo'!

MalTarjan subclass: #MalCyclesCoverage
	uses: MalTNormalize
	instanceVariableNames: 'circuits sccExtractorClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusExtraPlugin-JannikAlgo'!

MalCyclesCoverage class
	uses: MalTNormalize classTrait
	instanceVariableNames: ''!

!MalCyclesCoverage methodsFor: 'accessing' stamp: 'jl 3/26/2010 13:44'!
circuits
	^ circuits! !

!MalCyclesCoverage methodsFor: 'running' stamp: 'simondenier 3/17/2010 22:33'!
directCircuit: aCollection

	^ self normalize: (OrderedCollection with: aCollection first model with: aCollection second model)! !

!MalCyclesCoverage methodsFor: 'initialization' stamp: 'simon.denier 3/20/2010 19:03'!
initialize

	super initialize.
	self useNodeDecomposition ! !

!MalCyclesCoverage methodsFor: 'accessing' stamp: 'jl 3/26/2010 13:39'!
retrieveCircuitsFromSccExtractor: sccExtractor

	sccExtractor circuits do: [:c |
		circuits add: (c collect: [:n| n model]) ]! !

!MalCyclesCoverage methodsFor: 'running' stamp: 'jl 3/26/2010 13:38'!
run

	super run.
	circuits := OrderedCollection new.
	self stronglyConnectedComponents do: [:scc|
		(scc size > 2) ifTrue: [|sccExtractor|
			sccExtractor := sccExtractorClass new.
			sccExtractor nodes: scc.
			"graph injection remove outgoing edges from SCC"
			sccExtractor edges: scc from: #yourself toAll: #nextNodes.
			sccExtractor run.
			self retrieveCircuitsFromSccExtractor: sccExtractor ].
		(scc size = 2) ifTrue: [
			circuits add: (self directCircuit: scc) ]. "direct circuit"
		]! !

!MalCyclesCoverage methodsFor: 'running' stamp: 'BenjaminVanRyseghem 2/8/2012 17:26'!
useCircuitSpan

	"sccExtractorClass := MalCircuitSpanningEdges  "! !

!MalCyclesCoverage methodsFor: 'running' stamp: 'BenjaminVanRyseghem 2/8/2012 17:22'!
useEdgeDecomposition

	"sccExtractorClass := MalSccEdgeDecomposition "! !

!MalCyclesCoverage methodsFor: 'running' stamp: 'simon.denier 9/28/2010 13:18'!
useNodeDecomposition

	sccExtractorClass := MalSccNodeDecomposition ! !

!MalTarjan methodsFor: 'configuration' stamp: 'janniklaval 8/24/2011 15:17'!
nodeClass

	^ MalTarjanNode ! !

!MalTarjan methodsFor: 'running' stamp: 'simon.denier 7/6/2009 16:59'!
putOnStack: aTarjanNode

	stack push: aTarjanNode.
	aTarjanNode inStack: true. "I use a flag to avoid stack access"! !

!MalTarjan methodsFor: 'running' stamp: 'simondenier 2/11/2010 21:55'!
run
	"Tarjan's algorithm to detect strongly connected components (aka cycles) in O(m+n)"
	sccs := OrderedCollection new.
	stack := Stack new.
	runningIndex := 0.
	self nodes do: [ :n | n isTarjanUndefined ifTrue: [ self traverse: n ] ]! !

!MalTarjan methodsFor: 'accessing' stamp: 'simondenier 2/11/2010 21:51'!
stronglyConnectedComponents

	^ sccs ! !

!MalTarjan methodsFor: 'running' stamp: 'simondenier 2/11/2010 21:47'!
traverse: aTarjanNode 
	| pNode component |
	aTarjanNode tarjanIndex: runningIndex.
	aTarjanNode tarjanLowlink: runningIndex.
	runningIndex := runningIndex + 1.
	self putOnStack: aTarjanNode.
	aTarjanNode nextNodes do: [:next | 
		next isTarjanUndefined 
			ifTrue: 
				[ self traverse: next.
				aTarjanNode tarjanLowlink: (aTarjanNode tarjanLowlink min: next tarjanLowlink) ]
			ifFalse: 
				[ next inStack ifTrue: 
					[ aTarjanNode tarjanLowlink: (aTarjanNode tarjanLowlink min: next tarjanIndex) ]]].

	aTarjanNode tarjanIndex = aTarjanNode tarjanLowlink ifTrue: 
		[ component := OrderedCollection new.
		 [pNode := stack pop.
		  pNode popped.
		  component add: pNode ] doWhileFalse: [ pNode = aTarjanNode ].
		 sccs add: component.
		 component do: [:each| 
			each cycleNodes: component ]]! !

Object subclass: #MalGraphNode
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusExtraPlugin-JannikAlgo'!

!MalGraphNode class methodsFor: 'as yet unclassified' stamp: 'simon.denier 7/6/2009 17:01'!
with: aModel

	^ self new model: aModel! !

!MalGraphNode methodsFor: 'accessing' stamp: 'simon.denier 7/8/2009 18:41'!
from: sourceNode! !

!MalGraphNode methodsFor: 'accessing' stamp: 'simon.denier 7/8/2009 18:41'!
from: sourceNode edge: anEdge! !

!MalGraphNode methodsFor: 'accessing' stamp: 'simon.denier 7/6/2009 17:01'!
label

	^ 'N '! !

!MalGraphNode methodsFor: 'accessing' stamp: 'simon.denier 7/6/2009 17:01'!
model
	^ model! !

!MalGraphNode methodsFor: 'accessing' stamp: 'simon.denier 7/6/2009 17:01'!
model: aModel

	model := aModel! !

!MalGraphNode methodsFor: 'accessing' stamp: 'simon.denier 7/6/2009 17:01'!
printString

	^ self label, self model printString! !

!MalGraphNode methodsFor: 'accessing' stamp: 'simon.denier 7/6/2009 17:01'!
to: targetNode! !

!MalGraphNode methodsFor: 'accessing' stamp: 'simon.denier 7/6/2009 17:01'!
to: targetNode edge: anEdge! !

MalGraphNode subclass: #MalSndNode
	uses: MalTNodeNode
	instanceVariableNames: 'previousNodes nextNodes visited bfsAncestor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusExtraPlugin-JannikAlgo'!

MalSndNode class
	uses: MalTNodeNode classTrait
	instanceVariableNames: ''!

!MalSndNode methodsFor: 'accessing' stamp: 'simon.denier 3/20/2010 00:06'!
bfsAncestor
	^ bfsAncestor! !

!MalSndNode methodsFor: 'accessing' stamp: 'simon.denier 3/20/2010 00:06'!
bfsAncestor: anObject
	bfsAncestor := anObject! !

!MalSndNode methodsFor: 'initialize-release' stamp: 'simon.denier 3/20/2010 19:07'!
initialize

	previousNodes := OrderedCollection new.
	nextNodes := OrderedCollection new.! !

!MalSndNode methodsFor: 'accessing' stamp: 'simon.denier 3/20/2010 18:06'!
nextNodes
	^ nextNodes! !

!MalSndNode methodsFor: 'accessing' stamp: 'simon.denier 3/20/2010 18:06'!
nextNodes: anObject
	nextNodes := anObject! !

!MalSndNode methodsFor: 'accessing' stamp: 'simon.denier 3/20/2010 18:06'!
previousNodes
	^ previousNodes! !

!MalSndNode methodsFor: 'accessing' stamp: 'simon.denier 3/20/2010 18:06'!
previousNodes: anObject
	previousNodes := anObject! !

!MalSndNode methodsFor: 'accessing' stamp: 'simon.denier 3/20/2010 00:06'!
visited
	^ visited! !

!MalSndNode methodsFor: 'accessing' stamp: 'simon.denier 3/20/2010 00:06'!
visited: anObject
	visited := anObject! !

MalGraphNode subclass: #MalTarjanNode
	instanceVariableNames: 'nextNodes index lowlink inStack cycleNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NautilusExtraPlugin-JannikAlgo'!

!MalTarjanNode methodsFor: 'as yet unclassified' stamp: 'janniklaval 8/24/2011 15:15'!
cycleNodes
	^ cycleNodes! !

!MalTarjanNode methodsFor: 'as yet unclassified' stamp: 'janniklaval 8/24/2011 15:15'!
cycleNodes: anObject
	cycleNodes := anObject copy remove: self ; yourself! !

!MalTarjanNode methodsFor: 'as yet unclassified' stamp: 'janniklaval 8/24/2011 15:15'!
inStack
	^ inStack! !

!MalTarjanNode methodsFor: 'as yet unclassified' stamp: 'janniklaval 8/24/2011 15:15'!
inStack: anObject
	inStack := anObject! !

!MalTarjanNode methodsFor: 'as yet unclassified' stamp: 'janniklaval 8/24/2011 15:16'!
initialize
	nextNodes := Set new.
	index := -1.
	inStack := false! !

!MalTarjanNode methodsFor: 'as yet unclassified' stamp: 'janniklaval 8/24/2011 15:16'!
isInCycle

	^ self cycleNodes isEmpty not! !

!MalTarjanNode methodsFor: 'as yet unclassified' stamp: 'janniklaval 8/24/2011 15:16'!
isTarjanUndefined

	^ index = -1! !

!MalTarjanNode methodsFor: 'as yet unclassified' stamp: 'janniklaval 8/24/2011 15:16'!
label

	^ 'T '! !

!MalTarjanNode methodsFor: 'as yet unclassified' stamp: 'janniklaval 8/24/2011 15:16'!
nextNodes

	^ nextNodes! !

!MalTarjanNode methodsFor: 'as yet unclassified' stamp: 'janniklaval 8/24/2011 15:16'!
popped

	self inStack: false! !

!MalTarjanNode methodsFor: 'as yet unclassified' stamp: 'janniklaval 8/24/2011 15:16'!
tarjanIndex
	^ index! !

!MalTarjanNode methodsFor: 'as yet unclassified' stamp: 'janniklaval 8/24/2011 15:16'!
tarjanIndex: anInteger
	index := anInteger! !

!MalTarjanNode methodsFor: 'as yet unclassified' stamp: 'janniklaval 8/24/2011 15:16'!
tarjanLowlink
	^ lowlink! !

!MalTarjanNode methodsFor: 'as yet unclassified' stamp: 'janniklaval 8/24/2011 15:16'!
tarjanLowlink: anInteger
	lowlink := anInteger! !

!MalTarjanNode methodsFor: 'as yet unclassified' stamp: 'janniklaval 8/24/2011 15:17'!
to: aNode

	nextNodes add: aNode! !
